<?php
/*
 * Phamm - http://phamm.rhx.it - <phamm@rhx.it>
 * Copyright (C) 2004-2005 Alessandro De Zorzi and Mirko Grava
 *  
 * Phamm is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Phamm is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
* Setup wizard to create main config.inc.php file
*
* @package Phamm
* @author Alessandro De Zorzi <adezorzi@rhx.it>
**/

// Set the HTTP Charset Parameter as UTF-8
header("Content-type: text/html; charset=utf-8");

// Default style
$style = 'phamm';

// Require the library file with all functions
// require ('phamm_functions.inc.php');
// To develop include single file funtion
// this is not a safe way to include file :-P
$mydir = opendir('../functions');
while($fn = readdir($mydir))
{
    if (substr($fn,-3) == 'php')
        require ("../functions/$fn");
}
closedir($mydir);

// Require locale file
if (file_exists("./lang/$language.php"))
    require ("./lang/$language.php");
else
    require ("../en_GB.php");

if (file_exists("./config.inc.php.template"))
	include ('config.inc.php.template');

// User or default values
if (!$_POST['LDAP_SERVER'])
	$LDAP_SERVER='127.0.0.1';
else
	$LDAP_SERVER = $_POST['LDAP_SERVER'];

if (!$_POST['LDAP_PORT'])
	$LDAP_PORT='389';
else
	$LDAP_PORT = $_POST['LDAP_PORT'];

if (!$_POST['SUFFIX'])
	$SUFFIX='dc=example,dc=tld';
else
	$SUFFIX = $_POST['SUFFIX'];

if (!$_POST['admin'])
	$admin='manager';
else
	$admin = $_POST['admin'];
	
if ($_POST['USE_PLUGINS'])
	$USE_PLUGINS = $_POST['USE_PLUGINS'];
else
	$USE_PLUGINS = '0';

// Check the PHP version
$PHPVERSION=phpversion();

if (version_compare($PHPVERSION, "4.1.0", ">="))
{
	$phpCheck = TRUE;
	$phpCheckimg = "TRUE";
}
else
{
	$phpCheck = FALSE;
	$phpCheckimg = "FALSE";
}

// Check the LDAP extension
$LDAP_LOADED = extension_loaded('ldap');

if ($LDAP_LOADED == 1)
{
	$LDAP_ICON = TRUE;
	$LDAP_ICONimg = "TRUE";
}
else
{
	$LDAP_ICON = FALSE;
	$LDAP_ICONimg = "FALSE";
}

$step = $_GET['step'];
if (!$_GET['step'])
	$step = $_POST['step'];
$conf = $_GET['conf'];

// Read header template
include ('./style/phamm/header.html.php');

if (!$step)
{
	echo ("<H1>Setup wizard (Testing version)</H1>");
	echo ("<P class='error'>*** WARNING *** This is a beta version to create your config.inc.php</P>
	<P>Please use the <B>config.inc.php.template</B> to create your
	config.inc.php if you get some errors.</P>
	<P>Simply <B>cp config.inc.php.template config.inc.php</B> and edit it.</P>
	");
	echo $a;
	echo ("<TABLE class=\"data\">");
	echo ("<TR><TD>PHP</TD><TD>$PHPVERSION</TD><TD>");
	echo ("<IMG src=\"./style/phamm/img/$phpCheckimg.png\"></TD></TR>");
	echo ("<TR><TD>LDAP extension</TD><TD></TD><TD>");
	echo ("<IMG src=\"./style/phamm/img/$LDAP_ICONimg.png\"></TD></TR>");
	echo ("</TABLE>");

	if ($phpCheck == TRUE && $LDAP_LOADED)
	{
		echo ("<A href='?step=2'>Go --></A>");
	}
	else
	{
		echo ("<H2>Some problems occures</H2>");
		if (!$LDAP_LOADED)
		{
			echo "<P class='error'>LDAP extension not loaded!
			(Install php-ldap or php4-ldap, and check
			in your php.ini this line <BR><B>extension=ldap.so</P>)";
		}
	}
}


if ($step == '2')
{
	echo ("<FORM METHOD=\"POST\" ACTION=\"$_SERVER[PHP_SELF]\" name=\"add\">");
	echo ("<TABLE class=\"data\">");

	echo ("<INPUT type=\"hidden\" name=\"step\"
	value=\"2\">");

	echo ("<TR><TD>LDAP_SERVER</TD>
	<TD><INPUT type=\"text\" name=\"LDAP_SERVER\"
	value=\"$LDAP_SERVER\" size=\"20\"></TD></TR>");

	echo ("<TR><TD>LDAP_PORT</TD>
	<TD><INPUT type=\"text\" name=\"LDAP_PORT\"
	value=\"$LDAP_PORT\" size=\"5\"></TD></TR>");

	echo ("<TR><TD>SUFFIX</TD>
	<TD><INPUT type=\"text\" name=\"SUFFIX\"
	value=\"$SUFFIX\" size=\"40\"></TD></TR>");

	echo ("<TR><TD>admin</TD>
	<TD><INPUT type=\"text\" name=\"admin\"
	value=\"$admin\"></TD></TR>");
	
	echo ("</TABLE>");
	echo ("<INPUT type=\"submit\" value=\"Update\">");
	echo ("</FORM>");

	echo "<P class='error'>Copy and paste the text in your conf.inc.php</P>";

	echo "<FONT class='note'>Probably you want to edit the plugin
	config files in each plugin dir
	<B>example: plugins/mail/config.inc.php</B></FONT>
	";


	echo "<TEXTAREA cols='73' rows='20'>";
	echo '<?php'."\n";
	echo "// This is the main Phamm config file\n";
	echo "// Generated by setup.php ".date('Y'.'-'.'m'.'-'.'d')." ".date('H'.':'.'m')."\n";
	echo "////////////////////////////////////////////////////////\n\n";

	echo "// LDAP Server Settings\n";
	echo ("define (LDAP_HOST_NAME,'$LDAP_SERVER');\n");
	echo ("define (LDAP_PROTOCOL_VERSION,'3');\n");
	echo ("define (LDAP_PORT,'$LDAP_PORT');\n");
	echo ("define (SUFFIX,'$SUFFIX');\n");
	echo ("define (BINDDN,'cn=$admin,$SUFFIX');\n\n");

	echo '$LDAP_BASE'."= 'o=hosting,dc=example,dc=tld';\n\n";
	
	echo "// Phamm access control Settings\n";
	echo "define (NOLOGIN,0);\n";
	echo "define (SECRET,'rhx');\n";
	echo "define (FORCE_SSL,0);\n\n";
	
	echo "// Layout setting\n";
	echo "define (VERSION,'0.4.2');\n";
	echo "define (HIDE_VERSION,0);\n";
	echo "define (REFRESH_TIME,1);\n";
	echo "define (FUNNY_COLOR,0);\n";
	echo "define (LANG_MENU,'select');\n\n";
	echo "define (DEFAULT_VIEW,'all');\n\n";
	echo '$style'."	= \"phamm\";\n";
	echo '$language'." = \"en_GB\";\n";
	echo '$td_width'." = \"200\";\n";
	echo '$td_width_box'." = \"100\";\n";
	echo '$title'." = \"Phamm\";\n";

	echo '$supported_languages = array('."\n";
	echo "\"en_GB\" => \"English\",\n";
	echo "\"it_IT\" => \"Italiano\",\n";
	echo "// \"cc\" => \"Your language here\",\n";
	echo "\"fr_FR\" => \"Francais\",\n";
	echo "\"de_DE\" => \"Deutsch\",\n";
	echo "\"pt_BR\" => \"Brasileiro\",\n";
	echo "\"hu_HU\" => \"Magyar\",\n";
	echo "\"id_ID\" => \"Indonesian\",\n";
	echo "\"ru_RU\" => \"Russian\"\n";
	echo ");\n\n";
	
	
	echo "// PLUGINS SETTING\n";
	echo "define (DEFAULT_PLUGIN,'mail');\n\n";

	echo "// This array contains the active plugins name\n";
	echo '$plugins = array();'."\n";
	echo '$plugins[] = \'mail\';'."\n";
	echo '$plugins[] = \'pdns\';'."\n";
	echo "\n";
	
	echo "//  This array contains the TLDs (filter option)\n";
	echo '$tld = array();'."\n";
	echo '$tld[] = \'.com\';'."\n";
	echo '$tld[] = \'.net\';'."\n";
	echo '$tld[] = \'.org\';'."\n";
	echo "\n";

	echo "// Advanced settings - leave unchanged if unsure!\n";
	echo "define (DEBUG,0);\n";
	echo "define (ERROR_LEVEL,2);\n";
	echo "define (ADVANCED_VIEW,0);\n";
	echo "define (PHAMM_LOG,0);\n";
	echo "define (LOG_FILE,'/tmp/phamm.log');\n";
	echo "define (PASSWORD_MIN_LENGHT,3); // min password length\n";
	echo "define (PASSWORD_RND_LENGHT,6); // min password length\n\n";
	echo "define (ENC_TYPE,'CRYPT')\n";
	
	echo '?>';

	echo ("</TEXTAREA>");

}

// Read footer templates
include ('./style/phamm/footer.html.php');

?>
